#include <C:\Program Files (x86)\OpenNI2\Include\OpenNI.h>
#include <opencv2\opencv.hpp>

#ifdef _DEBUG
#pragma comment(lib, "opencv_core245d.lib")
#pragma comment(lib, "opencv_highgui245d.lib")
#pragma comment(lib, "opencv_imgproc245d.lib")
#pragma comment(lib, "opencv_video245d.lib")
#else
#pragma comment(lib, "opencv_core245.lib")
#pragma comment(lib, "opencv_highgui245.lib")
#pragma comment(lib, "opencv_imgproc245.lib")
#pragma comment(lib, "opencv_video245.lib")
#endif

#pragma comment(lib,"C:\\Program Files (x86)\\OpenNI2\\Lib\\OpenNI2.lib")
//C:\Program Files (x86)\OpenNI2\Lib

#include <vector>

class Kinect{
public:
	void Initialize(){
		openni::OpenNI::initialize();

		auto ret = device.open( openni::ANY_DEVICE );
		if ( ret != openni::STATUS_OK ) {
			throw std::runtime_error( "initialize error" );
		}
		else{
			std::cout << "initialize ok" << std::endl;
		}
	}

	void Colorimagestart(){
		colorStream.create( device, openni::SensorType::SENSOR_COLOR );
		colorStream.start();
		streams.push_back( &colorStream );
	}

	void Depthimagestart(){
		depthStream.create( device, openni::SensorType::SENSOR_DEPTH );
		depthStream.start();
		depthstreams.push_back( &depthStream );
	}

	void WaitforStream(int &changedIndex){
		openni::OpenNI::waitForAnyStream( &streams[0], streams.size(), &changedIndex );
	}

	void Getcolorimage(cv::Mat &colorimage){
		openni::VideoFrameRef colorFrame;
		colorStream.readFrame( &colorFrame );
		/*f[^Matɑ*/
		if ( colorFrame.isValid() ) {
			colorimage = cv::Mat( colorStream.getVideoMode().getResolutionY(),
				colorStream.getVideoMode().getResolutionX(),
				CV_8UC3, (char*)colorFrame.getData() );
		}
	}

	void getskeltondata(std::vector<cv::Point3f> &skeltonpoints){
		openni::VideoFrameRef depthFrame;
		depthStream.readFrame( &depthFrame );
		if ( depthFrame.isValid() ) {
			depthImage = cv::Mat( depthStream.getVideoMode().getResolutionY(),depthStream.getVideoMode().getResolutionX(),CV_16U, (char*)depthFrame.getData() );

			// 0-10000mm܂ł̃f[^0-255ɂ
			depthImage.convertTo( depthImage, CV_8U, 255.0 / 10000 );

			auto videoMode = depthStream.getVideoMode();
			short* depth = (short*)depthFrame.getData();
			/*3_̍W荞*/
			float wx,wy,wz;
			short pointdepth;
			cv::Point3f temppoint;
			std::vector<cv::Point3f> worldpoints; 
			for(int h =0;h<videoMode.getResolutionY(); h++){
				for(int w = 0; w< videoMode.getResolutionX();w++){
					pointdepth = depth[h * videoMode.getResolutionX()+w];
					openni::CoordinateConverter::convertDepthToWorld(depthStream,w,h,pointdepth,&wx,&wy,&wz);
					temppoint.x = wx;
					temppoint.y = wy;
					temppoint.z = wz;
					worldpoints.push_back(temppoint);
				}
			}
			skeltonpoints = worldpoints;
			cv::imshow( "Depth Camera", depthImage );
		}
	}
	
	void ClearStream(){
		colorStream.destroy();
		depthStream.destroy();
	}

	void Doalignment(){
		device.setImageRegistrationMode(openni::IMAGE_REGISTRATION_DEPTH_TO_COLOR);
	}

	int GetFrameHeight(int frameheight){
		frameheight = colorStream.getVideoMode().getResolutionY();
		return frameheight;
	}

	int GetFrameWidth(int framewidth){
		if(colorStream.isValid())
			framewidth = colorStream.getVideoMode().getResolutionX();
		//framewidth  = colorStream.getV
		return framewidth;
	}

protected:

	openni::Device device;
	openni::VideoStream colorStream;
	openni::VideoStream depthStream;
	std::vector<openni::VideoStream*> streams;
	std::vector<openni::VideoStream*> depthstreams;

	cv::Mat depthImage;

};